// FTPInfo.h: interface for the CFTPInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FTPINFO_H__7478D2AF_FC08_4D6D_ACEC_4DB7B1CD007A__INCLUDED_)
#define AFX_FTPINFO_H__7478D2AF_FC08_4D6D_ACEC_4DB7B1CD007A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SITE "http://www.delx.ca/dalbum"
#define AGENT "DAlbum Update utility 1.0 (c) 2003 DeltaX Inc."
class CFTPInfo  
{
public:
	CFTPInfo() {}
	virtual ~CFTPInfo() {}
	
	CString m_sName;
	CString m_sServer;
	int		m_nPort;
	BOOL	m_bPassive;

	CString m_sUser;
	CString m_sPassword;
	CString m_sPath;
};

class CFTPInfoArray
{
	CPtrArray m_Data;

	CString GetININame();
public:
	CFTPInfoArray()	{}
	~CFTPInfoArray()			{ while (GetSize()) RemoveAt(0); }
	int	 Add(CFTPInfo *p)		{ return m_Data.Add(p);	}
	void RemoveAt(int n)		{ delete (CFTPInfo *)m_Data[n];	m_Data.RemoveAt(n);}
	int  GetSize()				{ return m_Data.GetSize();}
	CFTPInfo *operator[](int n) { return (CFTPInfo *)m_Data[n];}

	BOOL	LoadINI();
	BOOL	SaveINI();
};



#endif // !defined(AFX_FTPINFO_H__7478D2AF_FC08_4D6D_ACEC_4DB7B1CD007A__INCLUDED_)
