// updalbumDlg.cpp : implementation file
//

#include "stdafx.h"
#include "updalbum.h"
#include "updalbumDlg.h"
#include "EditDlg.h"
#include "ProcessDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUpdalbumDlg dialog

CUpdalbumDlg::CUpdalbumDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUpdalbumDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUpdalbumDlg)
	m_nUpdate = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUpdalbumDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUpdalbumDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Radio(pDX, IDC_RADIO1, m_nUpdate);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUpdalbumDlg, CDialog)
	//{{AFX_MSG_MAP(CUpdalbumDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, OnDblclkList1)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnItemchangedList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUpdalbumDlg message handlers

BOOL CUpdalbumDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_FTP.LoadINI();

	CRect rc;
	m_List.GetClientRect(&rc);
	m_List.InsertColumn(0,"",LVCFMT_LEFT,rc.Width()*90/100);
	m_List.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	for (int i=0;i<m_FTP.GetSize();++i)
	{
		m_List.InsertItem(i,m_FTP[i]->m_sName);
	}
	UpdateButtons();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUpdalbumDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUpdalbumDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUpdalbumDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUpdalbumDlg::OnAdd() 
{
	CEditDlg dlg;
	if (dlg.DoModal()==IDOK)
	{
		CFTPInfo *p=new CFTPInfo ;
		p->m_sServer=dlg.m_sServer;
		p->m_sPath=dlg.m_sPath;
		p->m_nPort=dlg.m_nPort;
		p->m_bPassive=dlg.m_bPassive;
		p->m_sUser=dlg.m_sUser;
		p->m_sPassword=dlg.m_sPassword;
		p->m_sName=dlg.m_sName;
		
		int n=m_FTP.Add(p);
		m_List.InsertItem(n,p->m_sName);
		m_List.SetItemState(n,LVIS_FOCUSED | LVIS_SELECTED,LVIS_FOCUSED | LVIS_SELECTED);
		UpdateButtons();
	}
}

void CUpdalbumDlg::OnRemove() 
{
	int n=m_List.GetNextItem(-1,LVIS_FOCUSED);
	if (n!=-1)
	{
		m_List.DeleteItem(n);
		m_FTP.RemoveAt(n);
		m_List.SetItemState(max(n-1,0),LVIS_FOCUSED | LVIS_SELECTED,LVIS_FOCUSED | LVIS_SELECTED);
		UpdateButtons();;
	}
	
}

void CUpdalbumDlg::OnDblclkList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	OnEdit();
	UpdateButtons();
}

void CUpdalbumDlg::OnEdit() 
{
	int n=m_List.GetNextItem(-1,LVIS_FOCUSED);
	if (n!=-1)
	{
		CFTPInfo *p=m_FTP[n] ;
		CEditDlg dlg;
		dlg.m_sPassword=p->m_sPassword;
		dlg.m_sServer=p->m_sServer;
		dlg.m_sPath=p->m_sPath;
		dlg.m_sUser=p->m_sUser;
		dlg.m_nPort=p->m_nPort;
		dlg.m_bPassive=p->m_bPassive;
		dlg.m_sName=p->m_sName;
		if (dlg.DoModal()==IDOK)
		{
			p->m_sServer=dlg.m_sServer;
			p->m_sPath=dlg.m_sPath;
			p->m_nPort=dlg.m_nPort;
			p->m_bPassive=dlg.m_bPassive;
			p->m_sUser=dlg.m_sUser;
			p->m_sPassword=dlg.m_sPassword;
			p->m_sName=dlg.m_sName;
			m_List.SetItemText(n,0,dlg.m_sName);
			UpdateButtons();
		}
	}
	
}

void CUpdalbumDlg::UpdateButtons()
{
	int n=m_List.GetNextItem(-1,LVIS_FOCUSED);
	GetDlgItem(IDC_REMOVE)->EnableWindow(n>=0);
	GetDlgItem(IDC_EDIT)->EnableWindow(n>=0);
	
	GetDlgItem(IDOK)->EnableWindow(m_List.GetNextItem(-1,LVIS_SELECTED)!=-1);
}

void CUpdalbumDlg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	UpdateButtons();
	*pResult = 0;
}

void CUpdalbumDlg::OnCancel() 
{
	m_FTP.SaveINI();	
	CDialog::OnCancel();
}

void CUpdalbumDlg::OnOK() 
{
	UpdateData();

	POSITION pos=m_List.GetFirstSelectedItemPosition();

	CPtrArray ptr;
	while (pos)
	{
		int n=m_List.GetNextSelectedItem(pos);
		ptr.Add(m_FTP[n]);
	}
	
	if (ptr.GetSize())
	{
		CProcessDlg dlg(ptr,m_nUpdate);
		dlg.DoModal();
	}
}

