#if !defined(AFX_PROCESSDLG_H__E48B3C7E_6F52_4496_9398_FC6202B94D07__INCLUDED_)
#define AFX_PROCESSDLG_H__E48B3C7E_6F52_4496_9398_FC6202B94D07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ProcessDlg.h : header file
//
#include "FTPInfo.h"
/////////////////////////////////////////////////////////////////////////////
// CProcessDlg dialog

class CProcessDlg;
class CDAlbumSite
{
	DWORD	m_dwBuild;
	CString m_sCABFile,m_sVersion;
	CProcessDlg *m_pProcessDlg;
public:
	CDAlbumSite(CProcessDlg *pProcessDlg)
	{
		m_dwBuild=(DWORD)0;
		m_pProcessDlg=pProcessDlg;
	}
	~CDAlbumSite()
	{
		if (!m_sCABFile.IsEmpty())
			DeleteFile(m_sCABFile);
	}
	CString GetVersionStr(CInternetSession& session);
	DWORD GetBuild(CInternetSession& session);
	CString GetCABFile(CInternetSession& session);
};

class CProcessDlg : public CDialog
{
// Construction
	CPtrArray& m_FTP;

	CString m_sLog;
	
	BOOL m_bAll;

	BOOL m_bRunning;
	class CRunning
	{
		BOOL *m_b;
		HWND h;
	public:
		CRunning(HWND btn,BOOL *b) 
		{
			h=btn;
			m_b=b;
			::SetWindowText(btn,"Cancel");
			(*m_b)++;	
		}
		~CRunning() 
		{ 
			::SetWindowText(h,"Close");
			(*m_b)--;	
		}
	};

public:
	BOOL m_bCancel;
		
	CProcessDlg(CPtrArray& f, BOOL bAll, CWnd* pParent = NULL);   // standard constructor

	void ReportError(LPCTSTR szError, CException *p);

	CString GetTempFileName();
	

	void SetStatus(LPCTSTR szStat);
	void AddLog(LPCTSTR szStat);

	void Canceled()
	{
		AfxMessageBox("Operation canceled",MB_ICONINFORMATION);
		AddLog("\r\n\r\n--- Operation canceled ---\r\n");
	}
// Dialog Data
	//{{AFX_DATA(CProcessDlg)
	enum { IDD = IDD_PROCESS };
	CEdit	m_edLog;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProcessDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:
	void PumpMessages()
	{
		MSG msg;
		// Handle dialog messages
		while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if(!IsDialogMessage(&msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);  
			}
		}
	}
	

	// Generated message map functions
	//{{AFX_MSG(CProcessDlg)
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROCESSDLG_H__E48B3C7E_6F52_4496_9398_FC6202B94D07__INCLUDED_)
